<?php

namespace FiloBlu\Flow\Model\Actions\From;

class Translateattribute {

    CONST ENTITY_TYPE_CODE = 'product_attribute';

    public function __construct(
        \Magento\Framework\Model\Context $context,
        \Magento\Framework\Registry $registry,
        \FiloBlu\Flow\Helper\Attribute $helper_attribute,
        \Magento\Framework\Model\ResourceModel\AbstractResource $resource = null,
        \Magento\Framework\Data\Collection\AbstractDb $resourceCollection = null,
        array $data = []
    ) {
        $this->helper_attribute = $helper_attribute;
    }

    public function process($attribute, $value, $storeId = '') {

        $values = explode(';',$value);

        if(count($values) < 2)
        {
           // throw new \Exception("Empty translation");
    return;
        }
        $attributeValue = $values[0];
        $attributeTranslation = $values[1];

        $input_type = strtolower($attribute->getFrontend()->getInputType());

        if (strlen($attributeValue) > 0 && ($input_type === 'select' || $input_type === 'multiselect')) {
            $attributeOptionId = $attribute->setStoreId(0)->getSource()->getOptionId($attributeValue);
            if(empty($attributeOptionId)){
                $data = array(
                    'attribute_id'=>$attribute->getId(),
                    'store_id'  => 0,
                    'value'     => $attributeValue
                );
                if(! ($attributeOptionId = $this->helper_attribute->addAttributeOption($data)) ){
                    throw new \Exception("I wasn't able to add an attribute option");
                }

            }
            $data = array(
                'option_id' => $attributeOptionId,
                'store_id'  => $storeId,
                'value'     => $attributeTranslation
            );
            $this->helper_attribute->addAttributeTranslation($data);

        }else{
//            throw new \Exception("we only translate dropdown attriutes");
        }
    }

    protected function getAttributeOptionValue($attributeValue) {

        $attribute = \Magento\Framework\App\ObjectManager::getInstance()
            ->create('\Magento\Eav\Model\ResourceModel\Entity\Attribute\Option\CollectionFactory')
            ->create()
            ->join('eav_attribute', 'eav_attribute.attribute_id=main_table.attribute_id', 'attribute_code')
            ->join('eav_attribute_option_value', 'eav_attribute_option_value.option_id=main_table.option_id', 'value')
            ->addFieldToFilter('eav_attribute_option_value.value', array('eq' => $attributeValue))
            ->addFieldToFilter('attribute_code', array('eq' => $this->_attributeCode))
            ->getFirstItem();

//        $attribute = Mage::getModel('eav/entity_attribute_option')
//            ->getCollection()
//            ->setStoreFilter()
//            ->join('attribute', 'attribute.attribute_id=main_table.attribute_id', 'attribute_code')
//            ->addFieldToFilter('tdv.value', array('eq' => $attributeValue))
//            ->addFieldToFilter('attribute_code', array('eq' => $this->_attributeCode))
//            ->getFirstItem();

        return $attribute->getOptionId();
    }

}